#!/usr/bin/perl

#       .Copyright (C)  1999-2001 TUCOWS.com Inc.
#       .Created:       11/19/1999
#       .Contactid:     <admin@opensrs.org>
#       .Url:           http://www.opensrs.org
#       .Originally Developed by:
#                       VPOP Technologies, Inc. for Tucows/OpenSRS
#       .Authors:       Joe McDonald, Tom McDonald, Matt Reimer, Brad Hilton,
#                       Daniel Manley
#
#
#       This program is free software; you can redistribute it and/or
#       modify it under the terms of the GNU General Public License as
#       published by the Free Software Foundation; either version 2 of
#       the License, or (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful, but
#       WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#       General Public License for more details.
#
#       You should have received a copy of the GNU General Public License along
#       with this program; if not, write to the Free Software Foundation,
#       Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

use vars qw(
	    %in $cgi $path_templates %actions $action %cc_types $XML_Client
	    %contact_keys %data
	   );
(      %in, $cgi, $path_templates, %actions, $action, %cc_types, $XML_Client,
        %contact_keys, %data ) = ();

# pull in conf file with defined values
# XXX NOTE XXX Update this configuration file
BEGIN {
    do "c:/path/to/your/opensrs231/etc/OpenSRS.conf";
}

#use Data::Dumper;
use strict;
use lib $PATH_LIB;
use RACE;
do "$PATH_LIB/cgi-lib.pl";

use OpenSRS::XML_Client qw(:default);

# global defines
$cgi = $ENV{SCRIPT_NAME};
$path_templates = "$PATH_TEMPLATES/reg_system";
%in = ();

# list of valid actions to execute
%actions = (
	    lookup => undef,
	    check_transfer => undef,
	    check_upgrade => undef,
	    
	    setup_profile => undef,
	    do_setup_profile => undef,
	    
	    verify_order => undef,
	    register => undef,
	    
	    bulk_order => undef,
	    bulk_order_ca => undef,
	    bulk_transfer => undef,
	    do_bulk_transfer => undef,
	   );

%cc_types = (
	     visa => "Visa",
	     mastercard => "Mastercard",
	     amex => "American Express",
	 
	    );

%contact_keys = (
    	    	 first_name => undef,
    	    	 last_name => undef,
    	    	 address1 => undef,
    	    	 address2 => undef,
    	    	 address3 => undef,
    	    	 city => undef,
    	    	 state => undef,
    	    	 postal_code => undef,
    	    	 country => undef,
    	    	 email => undef,
    	    	 url => undef,
    	    	 fax => undef,
    	    	 phone => undef,
    	    	 org_name => undef,
    	    	);

###############################################
###############################################

print "Content-type:  text/html\n\n";

# set debugging level
start_up();

# create a client object which we will use to connect to the OpenSRS server
$XML_Client = new OpenSRS::XML_Client(%OPENSRS);
$XML_Client->login;

# read in the form data
ReadParse(\%in);

$action = $in{action};

# no action was supplied, so use the default
if (not $action) {
    main_menu();

# they passed a valid action
} elsif (exists $actions{$action}) {
    no strict "refs";
    &$action();
    use strict;

# they passed an invalid action
} else {
    main_menu("Invalid action: $action");
}

# close connection to the server
$XML_Client->logout;

exit;

####################################################################
### Begin subroutines
###################################################################

######################################################
## First, subroutines you may wish to adjust...
#####################################################

sub start_up {

    if ($REG_SYSTEM{debug}) {
	# print error to the page
	select (STDOUT); $| = 1;
	open (STDERR, ">&STDOUT") or die "Can't dump stdout: $!\n";
	select (STDERR); $| = 1;
	select (STDOUT);
    }
}

#
# Holy cow batman. This function creates an HTML link
# which allows people to register multi-ling domain names.
#
sub createMLDNSHTMLLink
{
    my $HTML	= shift;
    my ($mldns, $link);

    $HTML->{encoding_type} = $in{encoding_type};
    $HTML->{MLDNSType}	= $MLDNS{$in{encoding_type}} if $in{encoding_type} ne "";

    #
    # Build the MLDNS link line based on what they are allowed to sell.
    #
    foreach $mldns (sort keys %MLDNS)
    {
       next if $mldns eq $in{encoding_type};

       $link .= "<A HREF=\"$cgi?encoding_type=$mldns\">$MLDNS{$mldns}</A>&nbsp;&nbsp;";
    }

    if (defined $link)
    {
       $HTML->{MLDNS_LINK} = "<BR>Want to register a domain in a specific language?<BR>$link";
    }
}

#
# This returns 1/0 if we have an encoding type set.
#
sub checkEncodingType
{
   my %args		= @_;
   my $encoding_type	= $args{EncodingType};

   if ((defined $encoding_type) && ($encoding_type ne "") && ($encoding_type ne "iso-8899-1"))
   {
      return 1;
   }
   return 0;
}

#
# This takes a string, and an encoding type and tries to convert it.
# If the string encodes it contains out-of-bound characters. This
# is bad for addresses and things of that nature. Bad user, bad user,
# bad!. You like that don't you?
#
sub checkStringEncoding
{
   my %args		= @_;
   my $string		= $args{String};
   my $encoding_type	= $args{EncodingType};

   my $ret =  RACE::RACECheckRowZero ($string, $encoding_type);
   return 1 if $ret == 0;
   return 0;
}

sub main_menu {

    my (%HTML, $mldns);
    # no action was specified, so print main page
    
    $HTML{CGI} = $cgi;
    $HTML{affiliate_id} = $in{affiliate_id};

    #
    # MLDNS requires extra stuff...
    #
    createMLDNSHTMLLink (\%HTML);

    if ($CA_PREREG_PERIOD)
    {
	print_form("$path_templates/ca_main_menu.html",\%HTML);
    }
    else
    {
	print_form("$path_templates/main_menu.html",\%HTML);
    }
}

sub verify_order {
    
    # check fields for proper data
	
	# genie added my domain count... string to calculate totals
	my ($domain_count,$mytimeperiod,$mytotal_price,$PRICE_YEAR); 
	# genie end of mod
    
    my ($key,$cleaned_value,$error_msg,$domain_string,$domain,@domains);
    my (%good_domains,%bad_domains,%domains,$type,$field,$num,$fqdn,$nameservers);
    my ($raceObj, $originalDomain, $formCountry);
    my %converted_good_domains;
    my ($lookup_data, $fqdn_encoding_type);
    
    my $cc_num = $in{p_cc_num};
    my $cc_type = $in{p_cc_type};
    my $cc_exp_mon = $in{p_cc_exp_mon};
    my $cc_exp_yr = $in{p_cc_exp_yr};
    
    ##################################################################
    # here we check the validity of the cc_number, both its length
    # and its validity
    
    # only run this test if you set F_VERIFY_CC in conf file
    if ($REG_SYSTEM{F_VERIFY_CC}) {

	# check the cc number
	if (not cc_verify($cc_num)) {
	    error_out("Invalid credit card number.\n");
	    exit;
	}

	# check the expiration date
	if (not cc_exp_verify($cc_exp_mon,$cc_exp_yr)) {
	    error_out("Invalid credit card expiration: $cc_exp_mon/$cc_exp_yr.\n");
	    exit;
	}
    }

    # check for reg_username and reg_password
    if (not $in{reg_username}) {
	error_out("No username supplied");
	exit;
    } elsif (not $in{reg_password}) {
	error_out("No password supplied");
	exit;
    } elsif (defined $in{reg_password_confirm} and $in{reg_password} ne $in{reg_password_confirm}) {
	error_out("Password mismatch");
	exit;
    }

    #
    # Verify the username contains acceptable characters.
    #
    if (checkStringEncoding (String => $in{reg_username}, EncodingType => $in{encoding_type}) == 1)
    {
	error_out ("Username contains illegal characters.");
	exit;
    }
    if (checkStringEncoding (String => $in{reg_password}, EncodingType => $in{encoding_type}) == 1)
    {
	error_out ("Password contains illegal characters.");
	exit;
    }
    if (checkStringEncoding (String => $in{reg_password_confirm}, EncodingType => $in{encoding_type}) == 1)
    {
	error_out ("Confirmation password contains illegal characters.");
	exit;
    }
    
    ##################################################################
    ##################################################################
    
    ###################################
    # check syntax on domains given if this is a bulk order
    if ($in{bulk_order}) {	# this is a bulk order

	my $domains;
	if ($in{encoding_type})
	{
		$domains =$in{domains};
	}
	else
	{
		$domains = lc $in{domains};
	}
	my $syntaxError = undef;
	$domains =~ s/\r//g;
	$domains =~ s/\n/ /g;
	$domains =~ s/,/ /g;
	@domains = split /\s+/, $domains;
    
	$error_msg = "";
	# genie added loop to count for totals
	$domain_count = 0;
	# end of mod
	
	foreach $domain (@domains) {

            #
	    # check for duplicates
            #
	    if (exists $domains{$domain}) {
		$bad_domains{$domain} = "Duplicate domain.";
		next;
	    }

            #
            # RACE convert the name.
            #
            $raceObj = RACE::DoRACE (Domain => $domain, EncodingType => $in{encoding_type});
            #
            # Check syntax.
            #
            if ($syntaxError = check_domain_syntax($raceObj->{ConvertedDomain}))
            {
               $bad_domains{$originalDomain} = $syntaxError;
               next;
            }

	    if ( $raceObj->{ConvertedDomain} =~ /\.tv$/i ) {
		$bad_domains{$originalDomain} = '.tv domains are not supported for bulk orders.';
		next;
	    }

	    $lookup_data = {
			    action => "lookup",
			    object => "domain",
			    attributes => {
				domain => $raceObj->{ConvertedDomain},
				affiliate_id => $in{affiliate_id},
				}
			   };


	    # add the domain to the hash to check for duplicates
	    $domains{$domain} = 1;

	    if ($in{reg_type} eq 'new') {
		my $lookup_results = $XML_Client->send_cmd( $lookup_data );
		if ($lookup_results->{attributes}->{status} eq 'taken') {
		    $bad_domains{$domain} = "Domain taken.";
		    next;
		}
		if ($lookup_results->{attributes}->{status} eq 'invalid') {
		    $bad_domains{$domain} = "Error checking domain [".$lookup_results->{response_text}."].";
		    next;
		}
	    } else {
		$lookup_data->{action} = "check_transfer";
		$lookup_data->{object} = "domain";
		my $lookup_results = $XML_Client->send_cmd( $lookup_data );
		if ($lookup_results && $lookup_results->{is_success} == 1) {
		    if ($lookup_results->{attributes}->{transferrable} != 1) {
			$bad_domains{$domain} = "Domain not transferrable: $lookup_results->{attributes}->{reason}.";
			next;
		    }
		} else {
		    $bad_domains{$domain} = "Domain not transferrable: Error in check transfer [$lookup_results->{response_text}].";
		    next;
		}
		
	    }

	    $good_domains{$domain} = 1;

	}

	# if they didn't provide any good domains, error out now
	if (not keys %good_domains and keys %bad_domains) {
	    $error_msg = join("", map { "$_: $bad_domains{$_}<br>\n" } keys %bad_domains);
	}

	if ($error_msg) {
	    error_out($error_msg);
	    exit;
	}

    } else {			
	# this isn't a bulk order, but we still need to allow for a person
	# registering multiple domains with different tlds
	%good_domains = map { $_, 1 } split /\0/, $in{domain};
    }

    foreach $domain (keys %good_domains) {
	$domain_string .= "<input type=hidden name=domain value=\"$domain\">\n";

# genie added to increment count for totals
	$domain_count++; 
# end of mod	


    }
    
    #
    # Check the fields; make sure non are out of bound characters.
    #
    foreach $field (keys %in)
    {
       next if $field =~ /domain/i;	# Domain.
       next if $field =~ /^fqdn/i;	# Nameservers (1-6)

       if (checkStringEncoding (String => $in{$field}, EncodingType => $in{encoding_type}) == 1)
       {
          error_out ("Field ($field) contains illegal characters.");
          exit;
       }
    }

    my %HTML = %in;

    # copy over the normal contact info to 'billing' and/or 'tech' info 
    # if they had that flag set
    if (defined $in{flag_use_contact_info}) {
	foreach $key (keys %in) {
	    if ($key =~ /^billing_(.+)$/) {
		$HTML{$key} = $in{"owner_$1"};
	    }
	}
    }
    if (defined $in{flag_tech_use_contact_info}) {
	foreach $key (keys %in) {
	    if ($key =~ /^tech_(.+)$/) {
		$HTML{$key} = $in{"owner_$1"};
	    }
	}
    }

    # use library to verify the supplied data
    my ($custom_nameservers);
    if ($in{reg_type} eq 'new' and $REG_SYSTEM{custom_nameservers}) {
	$custom_nameservers = 1;
    } else {
	$custom_nameservers = 0;
    }

    # insert the domains into $HTML{domain} for the validation code below
    foreach my $dom (keys %good_domains)
    {
       my $hashRef = RACE::DoRACE (Domain => $dom, EncodingType => $in{encoding_type});
       if (! defined $hashRef->{ConvertedDomain})
       {
          error_out ("Domain $dom contains illegal characters.");
          exit;
       }

       $converted_good_domains{$hashRef->{ConvertedDomain}} = 1;
    }
    $HTML{domain} = join "\0", keys %converted_good_domains;

    my %verify_results = $XML_Client->validate(\%HTML, custom_tech_contact => $REG_SYSTEM{custom_tech_contact}, custom_nameservers => $custom_nameservers);

    if (not $verify_results{is_success}) {
	# there were problems with submitted data...
	$error_msg = $verify_results{error_msg};
	error_out($error_msg);
	exit;
    }

    # everything looks in order... so far...
    
    # pass along the tech contact info if the conf file tells us to
    # use %HTML so that "flag_tech_use_contact_info" is applied
    if ($REG_SYSTEM{custom_tech_contact}) {
	$HTML{TECH_CONTACT} = build_tech_verify(\%HTML);
    }

    # add 'tech' as a contact type if the conf file has that defined
    my @contact_types = ('owner','billing');
    if ($REG_SYSTEM{custom_tech_contact}) {
	push @contact_types, 'tech';
    }

    # encode the contact info and pass it to the next form
    foreach $type (@contact_types) {
	foreach $field (qw(first_name last_name org_name address1 address2 address3 city state postal_code country email phone fax)) {
	    $HTML{CONTACT_INFO} .= "<input type=hidden name=\"${type}_$field\" value=\"" . encode($HTML{"${type}_$field"}) . "\">\n";
	}
    }

    # make the display of this data look a little better
    if ($HTML{owner_address2}) { $HTML{owner_address2} .= "<br>\n" }
    if ($HTML{owner_address3}) { $HTML{owner_address3} .= "<br>\n" }
    if ($HTML{billing_address2}) { $HTML{billing_address2} .= "<br>\n" }
    if ($HTML{billing_address3}) { $HTML{billing_address3} .= "<br>\n" }

    # encode the nameserver info and pass it to the next form
    if ($custom_nameservers) {
	foreach $num (1..6) {
	    $fqdn = $in{"fqdn$num"};
	    $fqdn_encoding_type = $in{"fqdn".$num."_encoding_type"};
	    if ($fqdn) {
		$nameservers .= "$fqdn ".($fqdn_encoding_type?"<I>(".$fqdn_encoding_type.")</I>":"")."<br>\n";
		$HTML{NAMESERVER_INFO} .= "<input type=hidden name=\"fqdn$num\" value=\"" . encode(RACE::DoRACE(Domain => $fqdn, EncodingType => $fqdn_encoding_type)->{ConvertedDomain}) . "\">\n";
		$HTML{NAMESERVER_INFO} .= "<input type=hidden name=\"fqdn".$num."_encoding_type\" value=\"" . encode($fqdn_encoding_type) . "\">\n";
	    }
	}

	$HTML{NAMESERVERS} = <<EOF;
<tr><td colspan=2 align=center><b>Nameserver Information</b></td></tr>
<tr><td colspan=2 align=center>$nameservers</td></tr>
EOF
    }

    # encode the billing info and pass it to the next form
    $HTML{BILLING_INFO} .= "<input type=hidden name=\"p_cc_num\" value=\"" . encode($cc_num) . "\">\n";
    $HTML{BILLING_INFO} .= "<input type=hidden name=\"p_cc_type\" value=\"" . encode($cc_type) . "\">\n";
    $HTML{BILLING_INFO} .= "<input type=hidden name=\"p_cc_exp_mon\" value=\"" . encode($cc_exp_mon) . "\">\n";
    $HTML{BILLING_INFO} .= "<input type=hidden name=\"p_cc_exp_yr\" value=\"" . encode($cc_exp_yr) . "\">\n";
    $HTML{BILLING_INFO} .= "<input type=hidden name=\"auto_renew\" value=\"" . encode($in{auto_renew}) . "\">\n";




    # display the cc_type using our %cc_types hash at the top of the
    # script
    $HTML{p_cc_type} = $cc_types{$in{p_cc_type}};
    
    $HTML{domains} = join("<br>\n", keys %good_domains);
    if (keys %bad_domains) {
	$HTML{bad_domains} = "<b>Invalid Domains:</b><br>\n" . join("", map { "<font color=red>$_: $bad_domains{$_}</font><br>\n" } keys %bad_domains) . "<br>\n";;
    }

    $HTML{encoding_type} = $in{encoding_type};
    $HTML{domain_string} = $domain_string;
    $HTML{CGI} = $cgi;
    $HTML{affiliate_id} = $in{affiliate_id};
    $HTML{period_text} = $REG_PERIODS{$in{period}};
    $HTML{reg_username} = encode($in{reg_username});
    $HTML{reg_password} = encode($in{reg_password});
    $HTML{reg_domain} = encode($in{reg_domain});
    $HTML{reg_type} = $in{reg_type};
	$HTML{auto_renew} = ( $in{auto_renew} ? 'Yes':'No');
	
# genie adding Johns code
# 
# 
# John Keegan 
# john@rackshare.com 
# 9/25/00 
# rackshare.com 
# 
# pricing loop start 
# 
# test for TV ccTLD 
    if ( $in{domain} && $in{domain} =~ /\.tv/i ) { 
# domain name is Canadian ccTLD 
           	if ($in{period} eq '1') 
			{$PRICE_YEAR = '45.00';
			} else {
			if ($in{period} eq '2')
					{
					$PRICE_YEAR = '39.00';
					} else {
						if ($in{period} eq '3')
						{$PRICE_YEAR = '35.00';
							} else {
								if ($in{period} eq '5')
									{$PRICE_YEAR = '29.00';
									}
									
									  else {
										if ($in{period} eq '10')
										{$PRICE_YEAR = '25.00';
										}
										   }
									}
					}
					}			
        $mytimeperiod = $REG_PERIODS{$in{period}}; 
        $mytimeperiod =~ s/\W.*//; 
        $mytotal_price = ($PRICE_YEAR * $mytimeperiod * $domain_count); 
        $HTML{hosting} = $in{hosting}; 
        $HTML{total_price} = $mytotal_price; 
    } 
# test for UK ccTLD 
    else { 
        if ( $in{domain} && $in{domain} =~ /\.uk/i ) { 
# domain name is United Kingdom ccTLD 
        $PRICE_YEAR = '12.00'; 
        $mytimeperiod = $REG_PERIODS{$in{period}}; 
        $mytimeperiod =~ s/\W.*//; 
        $mytotal_price = ($PRICE_YEAR * $mytimeperiod * $domain_count); 
        $HTML{hosting} = $in{hosting}; 
        $HTML{total_price} = $mytotal_price; 
        } 
# nothing found, must be gTLD 
    else { 
# This must be a .com, .net or .org Domain Name 
        $PRICE_YEAR = '15.00'; 
        $mytimeperiod = $REG_PERIODS{$in{period}}; 
        $mytimeperiod =~ s/\W.*//; 
        $mytotal_price = ($PRICE_YEAR * $mytimeperiod * $domain_count); 
        $HTML{hosting} = $in{hosting}; 
        $HTML{total_price} = $mytotal_price; 
        } 
    } 
# pricing loop end 
# 
# 
# genie end of Johns code	
		
	
	
	
    if ($in{reg_type} eq 'new') {
	$HTML{reg_type_text} = 'New Domain';
	$HTML{action} = 'register';
    } else {
	if ($in{bulk_order}) {
	    $HTML{reg_type_text} = 'Batch Transfer';
	    $HTML{action} = 'do_bulk_transfer';
	} else {
	    $HTML{reg_type_text} = 'Transfer';
	    $HTML{action} = 'register';
	}
    }

    if ( ( $in{domain} &&
	   $in{domain} =~ /\.ca/i ) ||
	 ( $in{domain_country} &&
	   $in{domain_country} eq 'ca' ) ) {

    	$formCountry = "_ca";
	
	$HTML{isa_trademark} = $in{isa_trademark} ? "Yes" : "No";
	$HTML{domain_description} = $in{domain_description} ? $in{domain_description} : "<I>-none-</I>";
	$HTML{domain_description} =~ s/\n/<BR>/g;

	if ( $in{upgrade_option} )
	{
	    $HTML{reg_type_text} = 'Domain Upgrade';
	    $HTML{upgrade_option} = "Upgrading Existing Domain (".$in{upgrade_option}."ing orginal domain)<BR>".
	    	    "Original Domain: ".$in{old_domain}."<BR>";
	}
	if ( $in{ca_reg_type} eq 'prereg' )
	{
	    $HTML{reg_type_text} = 'Domain Pre-Registration';
	}

    	$HTML{legal_type} = $CA_LEGAL_TYPES{$in{legal_type}};
	$HTML{lang_pref} = ( $in{lang_pref} eq "EN" ) ? "English" : "Franais";

	$HTML{SPECIAL_DOMAIN_INFO} .= '<input type=hidden name="old_domain" value="' . $in{old_domain} . "\">\n";
	$HTML{SPECIAL_DOMAIN_INFO} .= '<input type=hidden name="ca_reg_type" value="' . ( $in{ca_reg_type} ? $in{ca_reg_type} : "advance" ) . "\">\n";
	$HTML{SPECIAL_DOMAIN_INFO} .= '<input type=hidden name="lang_pref" value="' . $in{lang_pref} . "\">\n";
	$HTML{SPECIAL_DOMAIN_INFO} .= '<input type=hidden name="isa_trademark" value="' . ( $in{isa_trademark} ? $in{isa_trademark} : "0" ) . "\">\n";
	$HTML{SPECIAL_DOMAIN_INFO} .= '<input type=hidden name="upgrade_flag" value="' . ($in{old_domain}?"1":"0") . "\">\n";
	$HTML{SPECIAL_DOMAIN_INFO} .= '<input type=hidden name="upgrade_option" value="' . $in{upgrade_option} . "\">\n";
	$HTML{SPECIAL_DOMAIN_INFO} .= '<input type=hidden name="legal_type" value="' . $in{legal_type} . "\">\n";
	$HTML{SPECIAL_DOMAIN_INFO} .= '<input type=hidden name="domain_description" value="' . $in{domain_description} . "\">\n";
	
    } else {
    	$formCountry = "";
    }
    
    print_form("$path_templates/verify$formCountry.html",\%HTML);
}

sub register {
    
    my (%HTML,$key,$xcp_request,$register_results,$error);
    my ($domain,$status,$id,$link_domains,$reg_type);
    my ($raceObj, $revDomain);

    $xcp_request = {
    		action => "sw_register",
		object => "domain",
		attributes => { 
		    contact_set => {},
		    nameserver_list => [],
		    },
    		};

    # clean up data that was posted, stick it in %data
    foreach $key (keys %in) {
	$in{$key} = unencode($in{$key});
    }

    my $sortorder = 1;
    # clean up data that was posted, stick it in %data
    foreach $key ( sort keys %in) {

	next if $key eq "domain";

    	if ( $key =~ /^(owner|billing|tech|admin)_/i )
	{
	    my $contact_type = $1;
	    my $contact_key = $key;
	    $contact_key =~ s/^(owner|billing|tech|admin)_//i;
	    if  ( exists $contact_keys{$contact_key} )
	    {
    	    	$xcp_request->{attributes}->{contact_set}->{$contact_type}->{$contact_key} =
		    	$in{$key};
	    }
	    next;
	}
    	
        #
        # Push the name servers list.
        #
    	if ( $key =~ /^fqdn\d+$/i )
	{
	    if  ( defined $in{$key} )
	    {
				# ikolomiets: Bug #1179
                # $raceObj = RACE::DoRACE (Domain => $in{$key}, EncodingType => $in{encoding_type});
				$raceObj = RACE::DoRACE (Domain => $in{$key}, EncodingType => $in{$key."_encoding_type"});
    	    	push @{$xcp_request->{attributes}->{nameserver_list}},
		    	{ name => $raceObj->{ConvertedDomain}, sortorder => $sortorder };
		$sortorder++;
	    }
	    next;
	}

	$xcp_request->{attributes}->{$key} = $in{$key};
    }

    #
    # Get a list of the domains and stick them into the list. This RACE
    # converts the name which in turn gets set off to the registrar.
    my @domains;
    foreach (split /\0/, $in{domain})
    {
       my $hashRef = RACE::DoRACE (Domain => $_, EncodingType => $in{encoding_type});
       if (! defined $hashRef->{ConvertedDomain})
       {
          error_out ("Domain $_ contains illegal characters.");
          exit;
       }

       push (@domains, $hashRef->{ConvertedDomain});
    }

    #
    # Set the encoding type of the domain name.
    #
    $xcp_request->{encoding_type} = $in{encoding_type};

    $xcp_request->{attributes}->{ca_reg_type} = 'prereg' if $in{old_domain};
    if ( $in{upgrade_flag} && $in{upgrade_option} eq 'keep' )
    {
	push @domains, $in{old_domain};
    }

    # if multiple domains are being registered based on a new profile,
    # send the necessary flag down to the server so they stay under the
    # same profile
    if (scalar @domains > 1 and not $xcp_request->{attributes}->{reg_domain}) {
	$link_domains = 1;
    }

    # tell the server whether or not we should override the reseller's
    # default tech contact info and nameserver info
    $xcp_request->{attributes}->{custom_tech_contact} = $REG_SYSTEM{custom_tech_contact};
    if ($in{reg_type} eq 'new' and $REG_SYSTEM{custom_nameservers}) {
	$xcp_request->{attributes}->{custom_nameservers} = 1;
    } else {
	$xcp_request->{attributes}->{custom_nameservers} = 0;
    }

	# add auto_renew option
	$xcp_request->{ attributes }{ auto_renew } = $in{ auto_renew };

    # attempt to register the domains one at a time...
    my $count = 1;
    foreach $domain (@domains) {

        #
        # Undo the race for display purposes.
        #
        $raceObj	= RACE::UndoRACE (Domain => $domain, EncodingType => $in{encoding_type});
        $revDomain	= $raceObj->{OriginalDomain};

    	# need to set the actio and object to lower case because
	# send_cmd() transforms them up.
	$xcp_request->{action} = lc $xcp_request->{action};
    	$xcp_request->{object} = lc $xcp_request->{object};

	$xcp_request->{attributes}->{domain} = $domain;

	# if this is the first of several domains based on a new profile
	# tell the server that this domain should be the primary domain for
	# the group of domains being processed
	if ($count == 1 and $link_domains) {
	    $xcp_request->{attributes}->{link_domains} = 1;
	} else {
	    $xcp_request->{attributes}->{link_domains} = 0;
	}
	
	# register the domain
	$register_results = $XML_Client->send_cmd( $xcp_request );
    
	if ($register_results->{is_success}) {
	
	    $id = $register_results->{attributes}->{id};

	    # if this is the first of several domains based on a new profile
	    # set its id as master_order_id so that when the other domains
	    # are inserted they are linked against the primary domain
	    if ($count == 1 and $link_domains) {
		$xcp_request->{attributes}->{master_order_id} = $id;
	    }
	    # only increment the count for successful orders
	    $count++;

            #
            # KLUDGE ALERT!!!!!!!!
            # Perl, for some reason, hacks and coughs on high-8 chars when performing an
            # append to a string. We perform the sprintf to avoid it. Change this and the
            # MLDN which appears on the screen will not be the one the user is requesting.
            # 
            my $x = sprintf ("%s processed with order # %d.<BR>\n", $revDomain, $id);
            $status .= $x;

	    ############################################################
	    # sample routine to send message to admin with billing info
	    
	    if ($REG_SYSTEM{F_SEND_ORDERS}) {
		if ($in{reg_type} eq 'new') {
		    $reg_type = "New Domain";
		} else {
		    $reg_type = "Transfer";
		}
		
                #
	        # sample routine to send message to customer
                # THINK: Email & RACE...
		send_email("$path_templates/message.txt",
			  {
			   %in,
			   domain =>  $domain,
			   mailfrom => $in{owner_email},
			   mailto => $ADMIN_EMAIL,
			   id => $id,
			   period_text => $REG_PERIODS{$in{period}},
			   reg_type => $reg_type,
			   });
	    }
	    

            #
	    # sample routine to send message to customer
            # THINK: Email & RACE...
	    if ($REG_SYSTEM{F_SEND_THANKYOU}) {
		send_email("$path_templates/thankyou.txt",
			  {
			   %in,
			   domain =>  $domain,
			   mailto => $in{owner_email},
			   mailfrom => $ADMIN_EMAIL,
			   id => $id,
			  });
	    }
	
	    ################################################################
	
	} else {

            #
            # KLUDGE ALERT!!!!!!!!
            # Perl, for some reason, hacks and coughs on high-8 chars when performing an
            # append to a string. We perform the sprintf to avoid it. Change this and the
            # MLDN which appears on the screen will not be the one the user is requesting.
            #
            my $x = sprintf ("Domain: %s Registration attempt failed: %s.", $revDomain, $register_results->{response_text});
            $status .= $x;
	
	    if ($register_results->{attributes}->{error}) {
		$register_results->{attributes}->{error} =~ s/\n/<br>\n/g;
		$status .= " $register_results->{attributes}->{error}";
		if ( $register_results->{response_code} == 486 )
		{
		    $status .= '&nbsp;&nbsp;&nbsp; Please retry in a minute or two.<BR>';
		}
	    }
	    
	    $status .= "<br>\n";
	}
    }

    $HTML{encoding_type} = $in{encoding_type};
    $HTML{status} = $status;
    $HTML{partner_email} = $ADMIN_EMAIL;
    $HTML{CGI} = $cgi;
    $HTML{affiliate_id} = $in{affiliate_id};

    $HTML{status} = $status;
    $HTML{partner_email} = $ADMIN_EMAIL;
    $HTML{CGI} = $cgi;
    $HTML{affiliate_id} = $in{affiliate_id};

    print_form("$path_templates/thankyou.html",\%HTML);
}

sub do_bulk_transfer {

    my (%HTML,%data,@params,$order_ids,$order_errors);
    my ($domain,$status,$id,$xcp_request);
    
    my @domains = split /\0/, $in{domain};

    $xcp_request = {
    	    	action => "bulk_transfer",
		object => "domain",
		attributes => {
		    	domain_list => \@domains,
		    	},
		};
		
    # clean up data that was posted, stick it in %data
    foreach my $key (keys %in) {
	$in{$key} = unencode($in{$key});
    }


    # clean up data that was posted, stick it in %data
    foreach my $key (keys %in) {

	next if $key eq "domain";

    	if ( $key =~ /^(owner|billing|tech|admin)_/i )
	{
	    my $contact_type = $1;
	    my $contact_key = $key;
	    $contact_key =~ s/^(owner|billing|tech|admin)_//i;
	    if  ( exists $contact_keys{$contact_key} )
	    {
    	    	$xcp_request->{attributes}->{contact_set}->{$contact_type}->{$contact_key} =
		    	$in{$key};
	    }
	    next;
	}
    	
	$xcp_request->{attributes}->{$key} = $in{$key};
    }

    # tell the server whether or not we should override the reseller's
    # default tech contact info and nameserver info
    $xcp_request->{attributes}->{custom_tech_contact} = $REG_SYSTEM{custom_tech_contact};
    $xcp_request->{attributes}->{custom_nameservers} = 0;

    my $register_results = $XML_Client->send_cmd( $xcp_request );

    # get the results for the entire transaction
    if ($register_results->{is_success}) {
	
	# get the results for each domain
	
	$status = $register_results->{response_text}."<BR><BR>";
	$status .= "Batch transfer order #".
	    	    $register_results->{attributes}->{bulk_transfer_id}.
		    "<BR>"; 
	foreach my $key ( @{$register_results->{attributes}->{successful_domains}}) {
	    my $domain = $key->{domain};
	    my $order_id = $key->{order_id};
	    
	    $status .= "$domain processed with order # $order_id.<br>\n";
	    $order_ids .= "$domain processed: order # $order_id\n";
	    
	}
	
	foreach my $key ( @{$register_results->{attributes}->{failure_domains}}) {
	    my $domain = $key->{domain};
	    my $reason = $key->{reason};
	    
	    $status .= "Unable to process transfer request for $domain: $reason<br>\n";
	    $order_errors .= "$domain failed: $reason\n";
	    
	}
	
	############################################################
	# sample routine to send message to admin with billing info
	
	if ($REG_SYSTEM{F_SEND_ORDERS}) {
	    send_email("$path_templates/bulk_transfer_message.txt",
		       {
			%in,
			bulk_transfer_id => $register_results->{attributes}->{bulk_transfer_id},
			mailfrom => $in{owner_email},
			mailto => $ADMIN_EMAIL,
			order_ids => $order_ids,
			order_errors => $order_errors,
		       });
	}
	
	# sample routine to send message to customer
	if ($REG_SYSTEM{F_SEND_THANKYOU}) {
	    send_email("$path_templates/bulk_transfer_thankyou.txt",
		       {
			%in,
			bulk_transfer_id => $register_results->{attributes}->{bulk_transfer_id},
			mailto => $in{owner_email},
			mailfrom => $ADMIN_EMAIL,
			order_ids => $order_ids,
		       });
	}
	
    } else {
	
	$status .= "Batch transfer attempt failed.<br><br>\n";
	$status .= "<menu>$register_results->{response_text}<br>\n";
	
	if ($register_results->{attributes}->{error}) {
	    $register_results->{attributes}->{error} =~ s/\n/<br>\n/g;
	    $status .= " $register_results->{attributes}->{error}";
	    if ( $register_results->{response_code} == 486 )
	    {
		$status .= '&nbsp;&nbsp;&nbsp; Please retry in a minute or two';
	    }
	}
	$status .= "</menu>\n";
	
	$status .= <<EOF;
<br><br>
If you would like to retry the order please hit your browser\'s 'Back' button
and re-submit the request.
EOF
	error_out($status);
	exit;
	
    }

    $HTML{status} = $status;
    $HTML{partner_email} = $ADMIN_EMAIL;
    $HTML{CGI} = $cgi;
    $HTML{affiliate_id} = $in{affiliate_id};
    $HTML{bulk_transfer_id} = $register_results->{bulk_transfer_id};
    print_form("$path_templates/bulk_transfer_thankyou.html",\%HTML);

}

# generic method to send an email based on a template and a hash ref of values
sub send_email {
    
    my ($template,$href) = @_;
    
    open (FILE, "<$template") or die "Couldn't open $template: $!\n";
    $/ = undef;
    my $message = <FILE>;
    $/ = "\n";
    close FILE;
    
    $message =~ s/{{(.*?)}}/$href->{$1}/g;
    
    my $mailto = $href->{mailto};
    my $mailfrom = $href->{mailfrom};
    
    if ($MAIL_TYPE eq 'sendmail') {
	open (MAIL, "|$MAILPROG") or die "Can't open $MAILPROG: $!\n";
	print MAIL $message;
	close MAIL or return undef;
    } else {
	send_smtp_mail($mailto,$mailfrom,$message) or return undef;
    }
    return 1;
}

###############################################################
###############################################################
### the rest of the subroutines should not need modification
###############################################################
###############################################################

sub lookup {
    
    my (%HTML,$status,$match_string,$matches);
    my ($xcp_request,$lookup_results,$match,$error_msg);
    my ($matchRef);
    
    my $domain		= $in{domain};
    my $affiliate_id	= $in{affiliate_id};

    #
    # RACE encode the domain name.
    #
    my $hashRef	= RACE::DoRACE (Domain => $domain, EncodingType => $in{encoding_type});
    if ($hashRef->{DomainConverted} == 1)
    {
       $xcp_request = {
    	    	action => "lookup",
		object => "domain",
		attributes => {
		    domain => $hashRef->{ConvertedDomain},
                    encoding_type => $in{encoding_type},
		    affiliate_id => $affiliate_id,
		    },
		};
    }
    else
    {
       $xcp_request = {
    	    	action => "lookup",
		object => "domain",
		attributes => {
		    domain => $domain,
		    affiliate_id => $affiliate_id,
		    },
		};

       #
       # The domain was not converted, force back to standard domain reg path.
       #
       $in{encoding_type}	= "";
    }
    
    $lookup_results = $XML_Client->send_cmd( $xcp_request );
    if ($lookup_results->{is_success}) {
	
	$status = $lookup_results->{attributes}->{status};
	if ($status eq 'available') {
	    
	    $matches = $lookup_results->{attributes}->{matches};
	    $match_string = <<EOF;
<center>
<input type=checkbox name=domain value="$domain" checked> $domain&nbsp;&nbsp;
EOF
	    my $counter = 1;
	    foreach $match (@$matches) {
		if ( $counter >= 3 )
		{
		    $match_string .= "<BR>";
		    $counter = 0;
		}

                #
                # Undo the race for display purposes.
                #
                $matchRef = RACE::UndoRACE (Domain => $match, EncodingType => $in{encoding_type});
                $match = $matchRef->{OriginalDomain};

		$match_string .= <<EOF;
<input type=checkbox name=domain value="$match"> $match&nbsp;&nbsp;
EOF
	    	$counter++;
	    }
	    $match_string .= "</center>\n";

	    $HTML{matches}	= $match_string;
	    $HTML{domain}	= $domain;
	    $HTML{CGI}		= $cgi;
	    $HTML{affiliate_id}	= $in{affiliate_id};

            createMLDNSHTMLLink (\%HTML);

	    my ( $tld ) = $domain =~ m/$OPENSRS_TLDS_REGEX$/i;
	    if ( exists $REG_SYSTEM{ post_lookup }{ $tld } ) {
		my $hr = $REG_SYSTEM{ post_lookup }{ $tld };
    
		no strict 'refs';
		&{$hr->{sub}}(\%HTML, $hr, $lookup_results);
		use strict;
	    }

	    print_form("$path_templates/avail.html",\%HTML);
	    
	} elsif ($status eq 'invalid') {
	    my $error_msg = "Your domain name: $domain was in an invalid format.\n";
	    error_out($error_msg);
	    exit;
	    
	} elsif ($status eq 'taken') {
	    # domain was taken
	    $matches = $lookup_results->{attributes}->{matches};

	    # only show order button if there were other available matches
	    if ( $matches ) {
		$match_string = "<b>The following similar domains are available:</b> <br><br><center>\n";
    	    	my $tempCounter = 0;
		foreach $match (@$matches) {
		    if ( $tempCounter >= 3 )
		    {
		    	$match_string .= "<BR>";
			$tempCounter = 0;
		    }
                my $matchRef2 = RACE::UndoRACE (Domain => $match, EncodingType => $in{encoding_type});
                $match = $matchRef2->{OriginalDomain};
		    $match_string .= <<EOF;
<input type=checkbox name=domain value="$match"> $match&nbsp;&nbsp;
EOF
		    $tempCounter++;
		}
		$match_string .= "</center>\n";

		$HTML{matches} = <<EOF;
<FORM method="post" ACTION="$cgi" >
<input type=hidden name=affiliate_id value="$in{affiliate_id}">
<input type=hidden name=action value="setup_profile">
<input type=hidden name=encoding_type value="$in{encoding_type}">

<TABLE  BORDER=0 CELLPADDING=0>
<TR><TD>
$match_string
<BR>
</TD>
</TR>

<TR><TD>
<CENTER>
<HR SIZE=1 width=80%>
</CENTER>

Proceed to the order form by clicking on the button below<BR>
or skip to the bottom of the page to check on another name.
<BR>
</TD></TR>

<TR><TD ALIGN=center valign=bottom colspan=3>
<INPUT TYPE="submit" VALUE="Reserve Now!">
</TD></TR></TABLE>
</FORM>
EOF

	    }

	    $HTML{domain}	= $domain;
	    $HTML{CGI}		= $cgi;
	    $HTML{affiliate_id}	= $in{affiliate_id};

            createMLDNSHTMLLink (\%HTML);

	    print_form("$path_templates/taken.html",\%HTML);
	    

	} elsif ($status eq 'manual') {

	    $HTML{domain} = $domain;

	    $match_string = <<EOF;
<center>
<input type=checkbox name=domain value="$domain" checked> $domain&nbsp;&nbsp;
EOF

	    $HTML{matches}	= $match_string;
	    $HTML{must_match_profile} = "1";
	    $HTML{CGI} = $cgi;
	    $HTML{affiliate_id} = $in{affiliate_id};
	    print_form("$path_templates/avail.html",\%HTML);

	} elsif ($status eq 'ca_prereg') {

	    $HTML{domain} = $domain;
	    $HTML{CGI} = $cgi;
	    $HTML{affiliate_id} = $in{affiliate_id};
	    print_form("$path_templates/ca_prereg.html",\%HTML);

	} elsif ($status eq 'ca_upgrade') {

	    $HTML{old_domain} = $domain;
	    $HTML{domain} = $lookup_results->{attributes}->{upg_to_subdomain};
	    $HTML{CGI} = $cgi;
	    $HTML{affiliate_id} = $in{affiliate_id};
	    print_form("$path_templates/ca_upgrade.html",\%HTML);

	} elsif ($status eq 'ca_noupgrade') {

	    $HTML{domain} = $domain;
	    $HTML{CGI} = $cgi;
	    $HTML{affiliate_id} = $in{affiliate_id};
	    print_form("$path_templates/ca_noupgrade.html",\%HTML);

    	}

    } else {
	$error_msg = $lookup_results->{response_text};
	error_out($error_msg);
	exit;
    }
    
}

sub info_tv {
    my ( $rHTML, $hr, $lookup_results ) = @_;

    my $domain = $in{ domain };

    # get the domain price
    if ( $lookup_results->{ attributes }{ price_status } eq 'AUCTION' ) {

	my %INFO = ( domain => $domain );
	$INFO{price} = get_price($domain);

	$rHTML->{CGI} = $hr->{ url } . "&domain=$domain";
	$rHTML->{post_lookup} = get_content( $hr->{ template }, \%INFO);
    }
}

sub get_price {
    my ($domain) = @_;

    my $xcp_request = {
	action => 'get_price',
        object => 'domain',
        attributes => {
            domain => $domain,
            period => 1,
        }
    };

    my $price_results = $XML_Client->send_cmd( $xcp_request );
    return $price_results->{attributes}{price};
}

sub check_transfer {

    my ($xcp_request,$domain_string,%HTML,$error_msg);

    my $domain = $in{domain};
    my $affiliate_id = $in{affiliate_id};

    $xcp_request = {
    	    	action => "check_transfer",
		object => "domain",
		attributes => {
		    domain => $domain,
		    affiliate_id => $affiliate_id,
		    },
	    	};
    
    my $transfer_check = $XML_Client->send_cmd( $xcp_request );
    if ($transfer_check->{is_success}) {
	if ($transfer_check->{attributes}->{transferrable} == 1) {
	    $domain_string = "<input type=hidden name=domain value=\"$domain\">\n";

	    $HTML{domain_string} = $domain_string;
	    $HTML{CGI} = $cgi;
	    $HTML{affiliate_id} = $affiliate_id;
	    $HTML{reg_type} = "transfer";
	    $HTML{bulk_order} = 0; # eg, not bulk
	    $HTML{title} = "Domain Transfer for $domain";
	    print_form("$path_templates/setup_profile.html",\%HTML);
	} else {
	    error_out("The domain $domain is not currently transferrable:  $transfer_check->{attributes}->{reason}.\n");
	    exit;
	}
    } else {
	$error_msg = $transfer_check->{response_text};
	error_out($error_msg);
	exit;
    }

}

sub check_upgrade {

    my ($xcp_request,$domain_string,%HTML,$error_msg,$upgradeDomain);

    my $domain = $in{domain};
    my $affiliate_id = $in{affiliate_id};

    $xcp_request = {
    	    	action => "lookup",
		object => "domain",
		attributes => {
		    domain => $domain,
		    check_upgrade => 1,
		    affiliate_id => $affiliate_id,
		    },
	    	};
    
    my $upgrade_check = $XML_Client->send_cmd( $xcp_request );
    if ($upgrade_check->{is_success}) {
	if ($upgrade_check->{attributes}->{status} eq 'ca_upgrade') {
	    $upgradeDomain = $upgrade_check->{attributes}->{upg_to_subdomain};
	    $domain_string = '<input type=hidden name=domain value="'.
	    	    $upgradeDomain.'">'."\n";

	    $HTML{domain_string} = $domain_string;
	    $HTML{CGI} = $cgi;
	    $HTML{affiliate_id} = $affiliate_id;
	    $HTML{reg_type} = "new";
	    $HTML{bulk_order} = 0; # eg, not bulk
	    $HTML{title} = "Upgrade $domain to $upgradeDomain";
	    $HTML{ca_hidden_fields} = '<input type=hidden name=ca_reg_type value="upgrade">'."\n";
	    $HTML{ca_hidden_fields} .= '<input type=hidden name=old_domain value="'.$domain.'">';
	    print_form("$path_templates/setup_profile_ca.html",\%HTML);
	} else {
	    error_out("This subdomain cannot be upgraded:  $upgrade_check->{attributes}->{reason}.\n");
	    exit;
	}
    } else {
	$error_msg = $upgrade_check->{response_text};
	error_out($error_msg);
	exit;
    }

}

sub setup_profile {
    
    my (%HTML,$domain,$domain_string,$domainCountry,$must_match);
 
    my @domains = split /\0/, $in{domain};
    if (not @domains) {
	error_out("You need to select at least one domain to register.\n");
	exit;
    }

    foreach $domain (@domains) {
	$domain_string .= "<input type=hidden name=domain value=\"$domain\">\n";
    }

    $HTML{encoding_type}	= $in{encoding_type};
    $HTML{domain_string} = $domain_string;
    $HTML{CGI} = $cgi;
    $HTML{affiliate_id} = $in{affiliate_id};
    $HTML{reg_type} = "new";

    if ( $in{domain} =~ /\.ca/ )
    {
	$HTML{ca_hidden_fields} = '<input type=hidden name=ca_reg_type value="'.$in{ca_reg_type}.'">'."\n";
	$HTML{ca_hidden_fields} .= '<input type=hidden name=old_domain value="'.$in{old_domain}.'">'
    	    if $in{old_domain};
	$domainCountry = "_ca" if $in{ca_reg_type} =~ /prereg/;
    }

    if ( $in{must_match_profile} )
    {
    	$must_match = "_must_match";
	if ( $in{domain} =~ /\.ca/ )
	{
	    $HTML{message} = <<EOF
This .ca domain is restricted and can only be registered if it is linked to an<BR>
an already active .ca domain with the same CIRA registrant.
EOF
	}
	else
	{
	    $HTML{message} = <<EOF
The registration of this domain is conditional on its registration being linked<BR>
with another existing active domain.
EOF
	}
    }
    $HTML{bulk_order} = 0;	# eg, not bulk
    my $domains = join ", ", @domains;
    $HTML{title} = "Domain Registration for $domains";
    print_form("$path_templates/setup_profile$domainCountry".$must_match.".html",\%HTML);
    
}

sub do_setup_profile {

    my (%HTML,$domain,$domain_string,@domains,$domain_info,$race,$field,
        $htmlForm,$domainCountry);

    my $reg_username = $in{reg_username};
    my $reg_password = $in{reg_password};
    my $confirm_password = $in{confirm_password};
    my $flag_get_userinfo = $in{flag_get_userinfo};
    my $reg_domain = $in{reg_domain};
    my $reg_encoding_type = $in{reg_encoding_type};
    
    if ($reg_username =~ /^\s*$/)
    {
	error_out("Please provide a username.\n");
	exit;
    }

    #
    # Check the user name. If it was converted chuck out an error.
    #
    if (checkStringEncoding (String => $reg_username, EncodingType => $in{encoding_type}) == 1)
    {
       error_out ("Username contains illegal characters 1.");
       exit;
    }

    #
    # Check the password. Don't bother checking both since if they are equal, we only
    # need to check one anyway. If they aren't the check below will kick 'em out.
    #
    if (checkStringEncoding (String => $reg_password, EncodingType => $in{encoding_type}) == 1)
    {
       error_out ("Password contains illegal characters 2.");
       exit;
    }

    #
    # Check the passwords. 
    #
    if ($reg_password ne $confirm_password)
    {
	error_out ("Password mismatch.\n");
	exit;
    }

    if (not $reg_password)
    {
	error_out("Please provide a password.\n");
	exit;
    }

    #
    # RACE convert the domain name.
    #
    if ((defined $reg_domain) && ($reg_domain ne "") )
    {
       $race = RACE::DoRACE (Domain => $reg_domain, EncodingType => $in{reg_encoding_type});
       if (defined $race->{Error})
       {
          error_out ("Domain name contains illegal characters.");
          exit;
       }
    }

    if ( ( $flag_get_userinfo ) &&
    	      ( not $reg_domain ) &&
	      ( $in{ca_reg_type} !~ /prereg|upgrade/ ) ) {
	error_out("Please provide a domain's profile to retrieve.\n");
	exit;
    }

    if ($flag_get_userinfo) {
	# base registration on existing profile
	# get profile based on domain/username/password
	my $xcp_request = {
			action => "get",
			object => "domain",
			attributes => {
			    type => "all_info",
			    affiliate_id => $in{affiliate_id},
			    reg_username => $reg_username,
			    reg_password => $reg_password,
			    domain => $race->{ConvertedDomain},
                            encoding_type => $in{reg_encoding_type},
			}
		       };
    
    	if ( $in{domain} =~ /ca$/ && $in{ca_reg_type} =~ /prereg|upgrade/ )
	{
	    $xcp_request->{attributes}->{type} = "whois";
	    if ( $in{ca_reg_type} eq 'upgrade' )
	    {
                $race = RACE::DoRACE (Domain => $in{old_domain}, EncodingType => $in{encoding_type});
                if (defined $race->{Error})
                {
                   error_out ("Domain name contains illegal characters.");
                   exit;
                }

		$xcp_request->{attributes}->{domain} = $race->{ConvertedDomain};
	    }
	    else
	    {
                $race = RACE::DoRACE (Domain => $in{domain}, EncodingType => $in{encoding_type});
                if (defined $race->{Error})
                {
                   error_out ("Domain name contains illegal characters.");
                   exit;
                }

		$xcp_request->{attributes}->{domain} = $race->{ConvertedDomain};
	    }
	    
	    $HTML{reg_profile} = "Based on whois";
	} else {
	    $HTML{reg_profile} = "Based on $reg_domain/$reg_username";
	}

        #
        # Send the domain lookup off. The RACE converted name is being sent.
        #
	$domain_info = $XML_Client->send_cmd( $xcp_request );
	if (not $domain_info->{is_success}) {
	    error_out("Failed attempt: $domain_info->{response_text}");
	    exit;
	}

	# process this through escape() to account for " and ' in the data
        escape_hash_values( $domain_info );
	#%HTML = map { $_, escape($domain_info{$_}) } keys %domain_info;

    	#
	# now have to convert object format into denormalized format
	#
	foreach my $typeKey ( keys %{$domain_info->{attributes}->{contact_set}} ) {
	    foreach my $dataKey ( keys %{$domain_info->{attributes}->{contact_set}->{$typeKey}} ) {
		$HTML{$typeKey."_".$dataKey} =
	    	    $domain_info->{attributes}->{contact_set}->{$typeKey}->{$dataKey};
	    }
	}
	
	delete $domain_info->{attributes}->{contact_set};

	my $fqdnCounter = 1;
	foreach my $nameserver ( @{$domain_info->{attributes}->{nameserver_list}} ) {
	    $HTML{"fqdn".$fqdnCounter} = $nameserver->{name};
	    $HTML{"fqdn".$fqdnCounter."_encoding_type"} = $nameserver->{encoding_type};
	    $fqdnCounter++;
	}

	foreach my $attrKey ( keys %{$domain_info->{attributes}} ) {
	    $HTML{$attrKey} = $domain_info->{attributes}->{$attrKey};
	}

	
	$HTML{reg_domain} = $reg_domain;
	$HTML{country_menu} = build_country_list($HTML{owner_country});
	$HTML{billing_country_menu} = build_country_list($HTML{billing_country});

    } else {
	# make a new profile
	$HTML{reg_profile} = "New";
	$HTML{country_menu} = build_country_list();
	$HTML{billing_country_menu} = $HTML{country_menu};
    }

    #
    # Check the fields; make sure non are out of bound characters.
    #
    foreach $field (keys %in)
    {
       next if $field =~ /domain/i;

       if (checkStringEncoding (String => $field, EncodingType => $in{encoding_type}) == 1)
       {
          error_out ("Field ($field) contains illegal characters.");
          exit;
       }
    }

    $HTML{CGI} = $cgi;
    $HTML{encoding_type} = $in{encoding_type};
    $HTML{reg_username} = $reg_username;
    $HTML{reg_password} = $reg_password;
    $HTML{affiliate_id} = $in{affiliate_id};
    $HTML{reg_type} = $in{reg_type};
    $HTML{bulk_order} = $in{bulk_order};
    $HTML{CC_YEARS} = build_select_menu(get_cc_years(),(localtime)[5] + 1900);

    if ($REG_SYSTEM{custom_tech_contact}) {
	$HTML{CUSTOM_TECH_CONTACT} = build_tech_contact(\%HTML);
    }

    # nameserver information is only relevant for new domains
    if ($in{reg_type} eq 'new' and $REG_SYSTEM{custom_nameservers}) {
	$HTML{CUSTOM_NAMESERVERS} = build_nameservers(\%HTML);
    }

    if ($in{reg_type} eq 'new') {
	# new domains
	if ($in{bulk_order}) {
	    $HTML{heading} = 'Batch Domain Registration';
	}
	$HTML{reg_text} = 'Registration';
	$HTML{reg_type_text} = 'New Domain';
    	if ( $in{domain} &&
	     $in{domain} =~ /uk$/i )
	{
	    $HTML{PERIOD_LIST} = build_select_menu(\%UK_REG_PERIODS,2);

	} elsif ( $in{domain} && $in{domain} =~ /\.tv$/i ) {
	    $HTML{PERIOD_LIST} = build_select_menu(\%TV_REG_PERIODS,1);
	} else {
	    $HTML{PERIOD_LIST} = build_select_menu(\%REG_PERIODS,1);
	}
    } else {
	# transfer
	if ($in{bulk_order}) {
	    $HTML{reg_type_text} = 'Batch Transfer';
	    $HTML{heading} = 'Batch Transfer';
	} else {
	    $HTML{reg_type_text} = 'Transfer';
	}
	$HTML{reg_text} = 'Transfer';
	$HTML{PERIOD_LIST} = build_select_menu(\%TRANSFER_PERIODS);
    }

    if ( ( $in{domain} &&
	   $in{domain} =~ /\.ca/i ) ||
	 ( $in{domain_country} &&
	   $in{domain_country} eq 'ca' ) )
    {
    	$domainCountry = "_ca";
	$HTML{ca_legal_type_menu} = build_select_menu(\%CA_LEGAL_TYPES, 'CCT');

	$HTML{ca_reg_type} = $in{ca_reg_type};
    	if ( $in{ca_reg_type} eq 'prereg' )
	{
	    $HTML{reg_text} = 'Pre-Registration';
	    $HTML{reg_type_text} = 'Pre-Registration';
	}
	elsif ( $in{ca_reg_type} eq 'upgrade' )
	{
	    $HTML{old_domain} = $in{old_domain};
	    $HTML{reg_text} = 'Upgrade';
	    $HTML{reg_type_text} = 'Upgrade';
    	    $HTML{upgrade_option} = <<EOF;
<TR>
	<TD ALIGN=right bgcolor="#e0e0e0"><B>Upgrade Option</B></TD>
	<TD>
	    <select name="upgrade_option">
		    <option value="keep">Keep
		    <option value="free">Free
	    </select>
	    the original domain ($in{old_domain}).
	</TD>
</TR>
EOF
	}
    }
    else
    {
    	$domainCountry = "";
    }
    
    if ($in{bulk_order}) {
	my $etypes;
	foreach my $key13 (keys %MLDNS)
        {
                $etypes .="<OPTION VALUE=\"" . $key13 . "\">" . $MLDNS{$key13} . "\n";
        }
	$HTML{ENCODING_TYPE_LIST} = $etypes;

	$htmlForm = "$path_templates/bulk_order$domainCountry.html";
    } else {
	@domains = split /\0/, $in{domain};
	foreach $domain (@domains) {
	    $domain_string .= "<input type=hidden name=domain value=\"$domain\">\n";
	}
	$HTML{domain_string} = $domain_string;
	$HTML{domains} = join "<br>\n", @domains;

	$htmlForm = "$path_templates/order$domainCountry.html";
    }
    
    print_form($htmlForm,\%HTML);
}

sub fancy_sort {

    my (@words,@ints);

    my @list = @_;
    
    foreach (@list) {
	if ($_ =~ /^\d+$/) {
	    push @ints, $_;
	} else {
	    push @words, $_;
	}
    }
    
    @words = sort @words;
    @ints = sort { $a <=> $b } @ints;
    
    return (@ints,@words);
    
}

sub build_select_menu {

    my ($key,$html);

    my $href = shift;
    my $default = shift;

    foreach $key (fancy_sort(keys %$href)) {
	if ($key eq $default) {
	    $html .= <<EOF;
<option value="$key" SELECTED> $href->{$key}
EOF
} else {
    $html .= <<EOF;
<option value="$key"> $href->{$key}
EOF
}
    }
    return $html;
}

sub build_country_list {
    
    my ($id,$title,$html);
    
    my ($default_id) = @_;
    
    if (not $default_id) { $default_id = 'US' }
    else {
	$default_id =~ tr/a-z/A-Z/;
    }
    
    open (FILE, "<$PATH_TEMPLATES/countries") or die "Can't open $PATH_TEMPLATES/countries: $!\n";
    while (<FILE>) {
	
	chomp;
	if (/^(\w{2})\s+(.+)/) {
	    $id = $1;
	    $title = $2;
	} else {
	    next;
	}
	
	if ($id eq $default_id) {
	    $html .= <<EOF;
<option value="$id" selected>$title
EOF
	} else {
	    $html .= <<EOF;
<option value="$id">$title
EOF
	}
    }
    close(FILE);
    return $html;
}


sub escape_hash_values {

    my $hash_ref = shift;
    foreach my $hash_key ( keys %$hash_ref )
    {
    	if ( ref( $hash_ref->{$hash_key} ) eq "HASH" )
	{
	    escape_hash_values( $hash_ref->{$hash_key} );
	}
    	elsif ( ref( $hash_ref->{$hash_key} ) eq "ARRAY" )
	{
	    escape_array_values( $hash_ref->{$hash_key} );
	}
	else
	{
    	    $hash_ref->{$hash_key} = escape( $hash_ref->{$hash_key} );
	}
    }
}

sub escape_array_values {

    my $array_ref = shift;
    foreach my $array_element ( @$array_ref )
    {
    	if ( ref( $array_element ) eq "HASH" )
	{
	    escape_hash_values( $array_element );
	}
    	elsif ( ref( $array_element ) eq "ARRAY" )
	{
	    escape_array_values( $array_element );
	}
	else
	{
    	    $array_element = escape( $array_element );
	}
    }
}

sub escape {
    my $string = shift;
    $string =~ s/\"/&quot;/g;
    return $string;
}

sub error_out {
    
    my (%HTML);
    $HTML{CGI} = $cgi;
    $HTML{ERROR} = shift;
    print_form("$path_templates/error.html",\%HTML);
    
}

##########################################################################
# substitute values on the specified template and print it to the client

# an optional 'type' arg can be passed: 'framed' specifies to pull in base.html
# as the outer frame and the given template as the inner frame
# 'single' specifies to use the given template alone
# the default behavior is 'framed'
sub print_form {
    
    my ($type,$content);

    my @args = @_;
    my ($template,$HTML) = @args[0,1];
    if ($args[2]) { $type = $args[2] }
    else { $type = 'framed' }

    if (not $HTML->{REG_ENCODING_TYPE_LIST})
    {
        my $etypes;
        foreach my $key13 (keys %MLDNS)
        {
                $etypes .="<OPTION VALUE=\"" . $key13 . "\">" . $MLDNS{$key13} . "\n";
        }
        $HTML->{REG_ENCODING_TYPE_LIST} = $etypes;
    }

    if ($type eq 'framed') {
	$HTML->{CONTENT} = get_content("$template",$HTML);
    
	open (FILE, "<$path_templates/base.html") or die "Couldn't open $path_templates/base.html: $!\n";
	while (<FILE>) {
	    s/{{(.*?)}}/$HTML->{$1}/g;
	    $content .= $_;
	}
	close FILE;
    } else {
	open (FILE, "<$template") or die "Couldn't open $template: $!\n";
	while (<FILE>) {
	    s/{{(.*?)}}/$HTML->{$1}/g;
	    $content .= $_;
	}
	close FILE;
    }
    print $content;
}

####################################################
# grab the contents of a template, substitute any supplied values, and return
# the results
sub get_content {
    
    my $content;
    
    my ($template,$HTML) = @_;
    open (FILE, "<$template") or die "Couldn't open $template: $!\n";
    while (<FILE>) {
	s/{{(.*?)}}/$HTML->{$1}/g;
	$content .= $_;
    } 
    close FILE;
    
    return $content;
    
}

###########################################################
#### sample routines for ordering domains in bulk

sub bulk_order {

    my $title = "Batch Domain Registration";
    $title = ".CA " . $title if $in{domain_country} eq 'ca';
    my %HTML = (
		CGI => $cgi,
		affiliate_id => $in{affiliate_id},
		domain_country => lc( $in{domain_country} ),
		reg_type => 'new',
		bulk_order => 1,
		title => $title,
		);
    print_form("$path_templates/setup_profile.html",\%HTML);
}

sub bulk_order_ca {

    my %HTML = (
		CGI => $cgi,
		affiliate_id => $in{affiliate_id},
		domain_country => "ca",
		reg_type => 'new',
		bulk_order => 1,
		title => 'Batch Domain Registration',
		);
    print_form("$path_templates/setup_profile.html",\%HTML);
}

sub bulk_transfer {

    my %HTML = (
		CGI => $cgi,
		affiliate_id => $in{affiliate_id},
		reg_type => 'transfer',
		bulk_order => 1,
		title => 'Batch Domain Transfer',
		);
    print_form("$path_templates/setup_profile.html",\%HTML);
}

sub send_smtp_mail {

    my ($iaddr,$paddr,$proto);

    my ($to,$from,$message ) = @_;

    no strict 'subs';

    $iaddr = inet_aton( $SMTP_SERVER );
    $paddr = sockaddr_in( $SMTP_PORT, $iaddr );
    $proto = getprotobyname( 'tcp' );
    socket( SOCK, PF_INET, SOCK_STREAM, $proto )  or return 0;
    connect( SOCK, $paddr )                       or return 0;
    receive_from_server( \*SOCK )                 or return 0;
    send_to_server( \*SOCK, "HELO $LOCALHOST" )   or return 0;
    receive_from_server( \*SOCK )                 or return 0;
    send_to_server( \*SOCK, "MAIL FROM: <$from>") or return 0;
    receive_from_server( \*SOCK )                 or return 0;
    send_to_server( \*SOCK, "RCPT TO: <$to>" )    or return 0;
    receive_from_server( \*SOCK )                 or return 0;
    send_to_server( \*SOCK, "DATA" )              or return 0;
    receive_from_server( \*SOCK )                 or return 0;
    send_to_server( \*SOCK, "$message\n." )       or return 0;
    receive_from_server( \*SOCK )                 or return 0;
    send_to_server( \*SOCK, "QUIT" )              or return 0;
    receive_from_server( \*SOCK )                 or return 0;
    close( SOCK )                                 or return 0;
    return 1;
}

sub send_to_server {
    my( $socket )  = shift;
    my( $message ) = shift;
    send( $socket, "$message\n", 0 ) or return 0;
    return 1;
}

sub receive_from_server {
    my( $socket ) = shift;
    my( $reply );
    while( $reply = <$socket> ) {
	return 0 if $reply =~ /^5/;
	last      if $reply =~ /^\d+ /;
    }
    return 1;
}

############################################################

sub get_cc_years {

    my (%years,$i);
    my $year = (localtime)[5];
    $year += 1900;

    for ($i = 0; $i <=5; $i++) {
	$years{$year} = $year;
	$year++;
    }

    return \%years;

}

sub cc_verify {
    my ($number) = @_;
    my ($i, $sum, $weight);

    return 0 if $number =~ /[^\d\s\-]/;

    $number =~ s/\D//g;

    return 0 unless length($number) >= 13 && 0+$number;

    for ($i = 0; $i < length($number) - 1; $i++) {
    $weight = substr($number, -1 * ($i + 2), 1) * (2 - ($i % 2));
    $sum += (($weight < 10) ? $weight : ($weight - 9));
    }

    return 1 if substr($number, -1) == (10 - $sum % 10) % 10;
    return 0;
}

sub cc_exp_verify {

    my ($cc_exp_mon,$cc_exp_yr) = @_;

    my ($month,$year) = (localtime)[4,5];
    $month++;
    $year += 1900;

    my $current_month = sprintf("%04d%02d",$year,$month);
    my $cc_exp = sprintf("%04d%02d",$cc_exp_yr,$cc_exp_mon);
    if ($current_month > $cc_exp) {
	return 0;
    }
    return 1;
}

sub build_tech_contact {
    
    my $data = shift;
    my $tech_country_menu = build_country_list($data->{tech_country});

    my $html = <<EOF;
<TR>
	<TD COLSPAN=2 bgcolor="#90c0ff" align=center>
		<B><FONT SIZE=+1>Tech Contact Information</FONT></B>
	</TD>
</TR>
<TR>
	<TD COLSPAN=2 bgcolor="#e0e0e0" align=center>
		<B>Same as Contact Information</B>
<input type=checkbox name="flag_tech_use_contact_info" value="1" checked>
	</TD>
</TR>
<TR>
	<TD ALIGN=right bgcolor="#90c0ff"><B>First Name:</B></TD>
	<TD><input name="tech_first_name" size=15 value="$data->{tech_first_name}"></TD>
</TR>
<TR>
	<TD ALIGN=right bgcolor="#90c0ff"><B>Last Name:</B></TD>
	<TD><input name="tech_last_name" size=15 value="$data->{tech_last_name}"></TD>
</TR>
<TR>
	<TD ALIGN=right bgcolor="#90c0ff"><B>Organization Name:</B></TD>
	<TD><input name="tech_org_name" size=39 value="$data->{tech_org_name}"></TD>
</TR>
<TR>
	<TD ALIGN=right bgcolor="#90c0ff"><B>Street Address:</B></TD>
	<TD><input name="tech_address1" size=39 value="$data->{tech_address1}"></TD>
</TR>
<TR>
	<TD ALIGN=right bgcolor="#90c0ff"><font color=red size=-1>
                *optional*</font> <B>(eg: Suite #245):</B></TD>
	<TD><input name="tech_address2" size=39 value="$data->{tech_address2}"></TD>
</TR>
<TR>
	<TD ALIGN=right bgcolor="#90c0ff"><font color=red size=-1>
                *optional*</font> <B>Address 3:</B></TD>
	<TD><input name="tech_address3" size=39 value="$data->{tech_address3}"></TD>
</TR>
<TR>
	<TD ALIGN=right bgcolor="#90c0ff"><B>City:</B></TD>
	<TD><input name="tech_city" size=15 value="$data->{tech_city}"></TD>
</TR>
<TR>
	<TD ALIGN=right bgcolor="#90c0ff"><B>State:</B></TD>
	<TD><input name="tech_state" size=15 value="$data->{tech_state}"></TD>
</TR>
<TR>
	<TD ALIGN=right bgcolor="#90c0ff"><B>Country:</B></TD>
	<TD><SELECT NAME="tech_country">
$tech_country_menu
 </SELECT></TD>
</TR>
<TR>
	<TD ALIGN=right bgcolor="#90c0ff"><B>Postal Code:</B></TD>
	<TD><input name="tech_postal_code" size=15 value="$data->{tech_postal_code}"></TD>
</TR>
<TR>
	<TD ALIGN=right bgcolor="#90c0ff"><B>Phone Number:</B></TD>
	<TD><input name="tech_phone" size=20 value="$data->{tech_phone}"> 
		<font size=-1> (eg. 416-555-1122)</font>
		</TD>
</TR>
<TR>
	<TD ALIGN=right bgcolor="#90c0ff"><font color=red size=-1>
		*optional*</font> <B>Fax Number:</B>
	</TD>
	<TD><input name="tech_fax" size=20 value="$data->{tech_fax}"></TD>
</TR>
<TR>
	<TD ALIGN=right bgcolor="#90c0ff"><B>Email:</B></TD>
	<TD><input name="tech_email" size=39 value="$data->{tech_email}"></TD>
</TR>
EOF

   return $html;					     
}

sub build_tech_verify {

    my $data = shift;

    my $tech_address2 = $data->{tech_address2};
    my $tech_address3 = $data->{tech_address3};
    if ($tech_address2) { $tech_address2 .= "<br>\n" }
    if ($tech_address3) { $tech_address3 .= "<br>\n" }

    my $html = <<EOF;
<tr><td colspan=2 align=center><b>Tech Contact Information</b></td></tr>

<tr>
<td valign=top>
$data->{tech_first_name} $data->{tech_last_name}<BR>
$data->{tech_org_name}<BR>
$data->{tech_address1}<BR>
$tech_address2
$tech_address3
$data->{tech_city}, $data->{tech_state} $data->{tech_postal_code}<BR>
$data->{tech_country}
</td>
<td valign=top>
Phone:$data->{tech_phone}<BR>
Fax:$data->{tech_fax}<BR>
E-mail:$data->{tech_email}<BR>
</td>
</tr>
EOF
    return $html;
}

sub build_nameservers {

    my (%fqdns,%nameservers,$key,$num,$fqdn_race_obj);

    my $data = shift;
    foreach $key (grep /^fqdn\d+$/, keys %$data) {

	($num) = $key =~ m/^fqdn(\d+)$/;
	$fqdns{$num} = $data->{$key};
    }

    my $count = 1;
    foreach $num (sort keys %fqdns) {
        $fqdn_race_obj	= RACE::UndoRACE (Domain => $fqdns{$num},
	    	    	    	    	  EncodingType => $data->{"fqdn".$count."_encoding_type"});
        
	$nameservers{"fqdn$count"} = $fqdn_race_obj->{OriginalDomain};
	$nameservers{"fqdn".$count."_encoding_type"} = $data->{"fqdn".$count."_encoding_type"};
	$count++;
    }

    #
    # We need to get a list of available 
    #
	

    my $html = <<EOF;
<TR>
	<TD COLSPAN=2 bgcolor="#90c0ff" align=center>
		<B><FONT SIZE=+1>DNS Information</FONT></B><br>Enter yours or leave in ours to get free domain parking on our servers.  You may change your DNS name servers any time via Manage Domain Control Panel.
	</TD>
</TR>
EOF
    $html .= <<EOF;
<TR>
	<TD ALIGN=right bgcolor="#90c0ff"><B>Primary DNS Hostname:</B><br>use ours<br>
	<font color=red>greg.magi.net</B></font></TD>
	<TD>
	    <input name="fqdn1" size=39 value="greg.magi.net"><BR>
	    <select name=fqdn1_encoding_type>
	    	<option value="">Standard English
EOF
    $html .= build_list_from_file("$PATH_TEMPLATES/encoding_types",$nameservers{fqdn1_encoding_type});
    $html .= <<EOF;
	    </select>
	</TD>
</TR>
EOF
    $html .= <<EOF;
<TR>
	<TD ALIGN=right bgcolor="#90c0ff"><B>Secondary DNS Hostname:</B><BR>use ours<br>
	<font color=red>	magi1.magi.net </B></font></TD>
	<TD>
	    <input name="fqdn2" size=39 value="magi1.magi.net"><BR>
	    <select name=fqdn2_encoding_type>
	    	<option value="">Standard English
EOF
    $html .= build_list_from_file("$PATH_TEMPLATES/encoding_types",$nameservers{"fqdn2_encoding_type"});
    $html .= <<EOF;
	    </select>
	</TD>
</TR>
EOF
    $html .= <<EOF;
<TR>
	<TD ALIGN=right bgcolor="#90c0ff"><font color=red size=-1>
                *optional*</font> <B>Third DNS Hostname:</B></TD>
	<TD>
	    <input name="fqdn3" size=39 value="$nameservers{fqdn3}"><BR>
	    <select name=fqdn3_encoding_type>
	    	<option value="">Standard English
EOF
    $html .= build_list_from_file("$PATH_TEMPLATES/encoding_types",$nameservers{fqdn3_encoding_type});
    $html .= <<EOF;
	    </select>
	</TD>
</TR>
EOF
    $html .= <<EOF;
<TR>
	<TD ALIGN=right bgcolor="#90c0ff"><font color=red size=-1>
                *optional*</font> <B>Fourth DNS Hostname:</B></TD>
	<TD>
	    <input name="fqdn4" size=39 value="$nameservers{fqdn4}"><BR>
	    <select name=fqdn4_encoding_type>
	    	<option value="">Standard English
EOF
    $html .= build_list_from_file("$PATH_TEMPLATES/encoding_types",$nameservers{fqdn4_encoding_type});
    $html .= <<EOF;
	    </select>
	</TD>
</TR>
EOF
    $html .= <<EOF;
<TR>
	<TD ALIGN=right bgcolor="#90c0ff"><font color=red size=-1>
                *optional*</font> <B>Fifth DNS Hostname:</B></TD>
	<TD>
	    <input name="fqdn5" size=39 value="$nameservers{fqdn5}"><BR>
	    <select name=fqdn5_encoding_type>
	    	<option value="">Standard English
EOF
    $html .= build_list_from_file("$PATH_TEMPLATES/encoding_types",$nameservers{fqdn5_encoding_type});
    $html .= <<EOF;
	    </select>
	</TD>
</TR>
EOF
    $html .= <<EOF;
<TR>
	<TD ALIGN=right bgcolor="#90c0ff"><font color=red size=-1>
                *optional*</font> <B>Sixth DNS Hostname:</B></TD>
	<TD>
	    <input name="fqdn6" size=39 value="$nameservers{fqdn6}"><BR>
	    <select name=fqdn6_encoding_type>
	    	<option value="">Standard English
EOF
    $html .= build_list_from_file("$PATH_TEMPLATES/encoding_types",$nameservers{fqdn6_encoding_type});
    $html .= <<EOF;
	    </select>
	</TD>
</TR>
EOF

    return $html;
}

